// Slight variation on code by Remzi Arpaci-Dusseau, available at:
//   http://pages.cs.wisc.edu/~remzi/OSTEP/Code/code-01.tgz
// To disable address space layout randomization (ASLR) in Linux you can
//   use the following bash command:
//	$ setarch `uname -m` -R /bin/bash

#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <assert.h>

int main(int argc, char *argv[]) {
    if (argc != 2) { 
		fprintf(stderr, "usage: mem <value>\n"); 
		exit(1); 
    } 
    
    int *p;                   // memory for pointer is on "stack"
    
    p = malloc(sizeof(int));  // malloc'd memory is on "heap"
    assert(p != NULL);
    printf("(pid:%d) addr of p:        %p\n", (int) getpid(), &p);
    printf("(pid:%d) addr stored in p: %p\n", (int) getpid(), p);
    *p = atoi(argv[1]); // assign value to addr stored in p
    while (1) {
		usleep(1000000);
		*p = *p + 1;
		printf("(pid:%d) value of *p: %d\n", getpid(), *p);
    }

    return 0;
}

